module MatchMate
  class AddressMatchList
    include Enumerable

    def initialize(address_object_or_string, list = [])
      @address = address_object_or_string
      @list = list
    end

    def each(&block)
      scored_list.sort.each(&block)
    end

    def scored_list
      @scored_list ||= @list.map { |address_object_or_string| AddressMatchListItem.new address_object_or_string, @address }
    end
  end

  class AddressMatchListItem
    include Comparable

    attr_reader :address
    delegate :score, :match?, to: :matcher

    def initialize(address_object_or_string, other_address)
      # Accepts any address object that responds to a to_s method
      @address = address_object_or_string
      @other_address = other_address
    end

    def matcher
      @matcher ||= AddressMatcher.new(@address, @other_address)
    end

    def <=>(other)
      other.score <=> score
    end
  end
end
