module MatchMate
  DEFAULTS = {
    languages: ['en'],
    address_threshold: 80,
    address_weights: {
      road: {
        weight: 30,
        threshold: 80
      },
      unit: {
        weight: 2,
        threshold: 80
      },
      postcode: {
        weight: 30,
        threshold: 100
      },
      city: {
        weight: 8,
        threshold: 80
      },
      house_number: {
        weight: 30,
        threshold: 100
      }
    }
  }.freeze

  def self.configure
    yield config
  end

  def self.config
    @config ||= Configuration.new
  end

  class Configuration
    attr_accessor :python_path, :postcode_limit, :address_weights, :address_threshold, :languages
  end
end
